/* --------------------------------------------------------
 Generated by Lukman Hakim using sql2java (http://sql2java.sourceforge.net/ )
 jdbc driver used at code generation time: net.sourceforge.jtds.jdbc.Driver
 
 Author : Lukman Hakim (lukman.uki@gmail.com) 
 Date Created : 26/10/2017
 --------------------------------------------------------
*/
package com.portofolio.dao;

import java.util.List;
import java.util.Map;

import org.springframework.cache.annotation.Cacheable;
import org.springframework.context.annotation.Lazy;
import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import org.springframework.data.jpa.repository.Query;
import org.springframework.data.repository.CrudRepository;
import org.springframework.data.repository.query.Param;
import org.springframework.stereotype.Repository;

import com.portofolio.entity.Kelas;
import com.portofolio.entity.vo.KelasId;

@Lazy
@Repository
public interface KelasDao extends CrudRepository<Kelas, KelasId> {

	@Cacheable("KelasDaofindOneBy")
	Kelas findOneByIdKodeAndIdKdProfileAndKdDepartemen(String kode, Integer kdProfile, String KdDepartemen);

	@Query(QListAll + " and model.namaKelas like %:namaKelas% and model.kdKelasHead is null ")
	@Cacheable("KelasDaoFindAllList")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKelas") String namaKelas,
			Pageable page, @Param("kdDepartemen") String kdDepartemen);

	@Query(QListAll + " and model.namaKelas like %:namaKelas% and model.kdKelasHead=:kdKelasHead ")
	@Cacheable("KelasDaoFindAllListPage")
	Page<Map<String, Object>> findAllList(@Param("kdProfile") Integer kdProfile, @Param("namaKelas") String namaKelas,
			Pageable page, @Param("kdDepartemen") String kdDepartemen, @Param("kdKelasHead") String kdKelasHead);

	@Query(QListAll + " and model.id.kode like :kode")
	@Cacheable("KelasDaoFindByKode")
	Map<String, Object> findByKode(@Param("kdProfile") Integer kdProfile, @Param("kode") String kode,
			@Param("kdDepartemen") String kdDepartemen);
	
	@Query(" select new map(model.id.kdKelas as kdKelas,model.id.kdProfile as kdProfile, model.namaKelas as namaKelas) from Kelas model where model.id.kdProfile=:kdProfile and model.statusEnabled=true")
	List<Map<String, Object>> findAllData(@Param("kdProfile") Integer kdProfile);
	
	String QListAll = "select new map(model.id.kdKelas as kdKelas,model.id.kdProfile as kdProfile " + ", model.namaKelas as namaKelas "
			+ ", model.reportDisplay as reportDisplay " + ", model.noUrut as noUrut "
			+ ", model.kdKelasHead as kdKelasHead " + ", kelasHead.namaKelas as namaKelasHead "
			+ ", model.kodeExternal as kodeExternal " + ", model.namaExternal as namaExternal "
			+ ", model.kdDepartemen as kdDepartemen " + ", model.statusEnabled as statusEnabled "
			+ ", model.noRec as noRec " + ", departemen.namaDepartemen as namaDepartemen, model.version as version )"
			+ " from Kelas model left join model.id id left join model.departemen departemen "
			+ " left join model.kelasHead as kelasHead " + "where id.kdProfile=:kdProfile "
			+ "and departemen.id.kdProfile=id.kdProfile " + "and model.kdDepartemen =:kdDepartemen ";
		
	@Query("select new map(model.id.kdKelas as kdKelas,model.id.kdProfile as kdProfile, model.namaKelas as namaKelas) from Kelas model where id.kdProfile=:kdProfile and model.kdKelasHead =:kode")
	Map<String, Object> findByKodeHead(@Param("kdProfile") Integer kdProfile, @Param("kode") String kode );

}
